package szakdolgozat;

import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;

public class MyFunction {
	List<Point2D.Double> pointList;
	double x1;
	double x2;
	String f;
	public MyFunction(String function, double x1, double x2){
		pointList = new ArrayList<Point2D.Double>();
		double y;
		this.x1 = x1;
		this.x2 = x2;
		f=function;
		for(double i=x1;i<=x2;){
			i=(double)(Math.round((i*10)))/10;
			ExpressionSolverProgram supportProgram = new ExpressionSolverProgram(function,i,0);
			supportProgram.start();
			String vegeredmeny=supportProgram.result;
			y=(double)(Math.round((Double.parseDouble(vegeredmeny)*10)))/10;
			System.out.println("x,y"+i+","+y);
			pointList.add(new Point2D.Double(i,y));
			i=i+0.1;
		}

	}

	public MyFunction(String function){
		pointList = new ArrayList<Point2D.Double>();
		double y;
		this.x1 = -15;
		this.x2 = 15;
		f=function;
		for(double i=x1;i<=x2;){
			i=(double)(Math.round((i*10)))/10;
			ExpressionSolverProgram supportProgram = new ExpressionSolverProgram(function,i,0);
			supportProgram.start();
			String vegeredmeny=supportProgram.result;
			y=(double)(Math.round((Double.parseDouble(vegeredmeny)*10)))/10;
			System.out.println("x,y"+i+","+y);
			pointList.add(new Point2D.Double(i,y));
			i=i+0.1;
		}

	}

	public List<Point2D.Double> getPointList() {
		return pointList;
	}


	public double getX1() {
		return x1;
	}


	public double getX2() {
		return x2;
	}


	public String getF() {
		return f;
	}


	public Point calculatePoint(Point2D.Double p, int rateSpace, Point O){
		return new Point((int)(O.x + rateSpace*p.x),(int)(O.y - rateSpace*p.y));
	}

	public void drawMyFunction(Graphics2D g2, int rateSpace, Point O){
		for(int i=1;i<pointList.size();i++){
			g2.drawLine(calculatePoint(pointList.get(i-1), rateSpace, O).x, calculatePoint(pointList.get(i-1), rateSpace, O).y, calculatePoint(pointList.get(i), rateSpace, O).x, calculatePoint(pointList.get(i), rateSpace, O).y);
		}
	}
}
